routes/web.php
<?php

use App\Http\Controllers\Admin\AdminPagesController;
use App\Http\Controllers\Admin\CarsController;
use App\Http\Controllers\Admin\ArticlesController;
use App\Http\Controllers\ArticlesController as BaseArticles;
use App\Http\Controllers\BasketController;
use App\Http\Controllers\CallbackController;
use App\Http\Controllers\CatalogController;
use App\Http\Controllers\Manager\ManagerPagesController;
use App\Http\Controllers\OrdersController;
use App\Http\Controllers\PagesController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\SalonsController;
use App\Http\Controllers\ServiceController;
use App\Http\Controllers\TestDriveController;
use Illuminate\Routing\Router;
use Illuminate\Support\Facades\Route;

Route::get('/', [PagesController::class, 'homepage'])->name('home');

Route::get('/about', [PagesController::class, 'about'])->name('about');

Route::get('/catalog/{slug?}', [CatalogController::class, 'catalog'])->name('catalog');
Route::get('/products/{car:id}', [CatalogController::class, 'product'])->name('product');

Route::get('/salons', [SalonsController::class, 'index'])->name('salons.index');

Route::get('/basket', [BasketController::class, 'show'])->name('basket');
Route::post('/basket', [BasketController::class, 'addProduct'])->name('basket.addProduct');
Route::delete('/basket/deleteProduct/', [BasketController::class, 'deleteProduct'])->name('basket.deleteProduct');
Route::delete('/basket/removeProduct', [BasketController::class, 'removeProduct'])->name('basket.removeProduct');

Route::get('/callback', [CallbackController::class, 'show'])->name('callback.show');
Route::post('/callback', [CallbackController::class, 'store'])->name('callback.store');
Route::post('/callback/{id}', [CallbackController::class, 'update'])->name('callback.update');

Route::get('/test-drive', [TestDriveController::class, 'show'])->name('test-drive.show');
Route::post('/test-drive', [TestDriveController::class, 'store'])->name('test-drive.store');

Route::get('/service', [ServiceController::class, 'show'])->name('service.show');

Route::middleware('auth')->group(function () {
    Route::get('/basket', [BasketController::class, 'show'])->name('basket');
    Route::post('/basket', [BasketController::class, 'addProduct'])->name('basket.addProduct');
    Route::delete('/basket/deleteProduct/', [BasketController::class, 'deleteProduct'])->name('basket.deleteProduct');
    Route::delete('/basket/removeProduct', [BasketController::class, 'removeProduct'])->name('basket.removeProduct');
});

Route::get('/articles', [BaseArticles::class, 'index'])->name('articles.index');
Route::get('/articles/{slug}', [BaseArticles::class, 'show'])->name('articles.show');

Route::prefix('admin')
    ->name('admin.')
    ->middleware(['auth', 'role:admin'])
    ->group(function (Router $router) {
        $router->get('/', [AdminPagesController::class, 'admin'])->name('admin');
        $router->resource('cars', CarsController::class)->except(['show']);
        $router->resource('articles', ArticlesController::class)->except(['show']);
    })
;

Route::prefix('test-drive')
    ->name('manager.test-drive.')
    ->middleware(['auth', 'role:manager'])
    ->group(function (Router $router) {
        $router->post('/{id}', [TestDriveController::class, 'update'])->name('update');
        $router->get('/{id}/edit', [TestDriveController::class, 'edit'])->name('edit');
        $router->delete('/{id}', [TestDriveController::class, 'destroy'])->name('destroy');
    })
;

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
    Route::post('/profile/orders', [OrdersController::class, 'store'])->name('orders.create');
});

Route::prefix('manager')
    ->name('manager.')
    ->middleware(['auth', 'role:manager'])
    ->group(function (Router $router) {
        $router->get('/', [ManagerPagesController::class, 'manager'])->name('manager');
    })
;

require __DIR__.'/auth.php';

app/Models/Car.php
<?php

namespace App\Models;

use App\Contracts\HasTagsContract;
use App\Enums\ModelStatus;
use Illuminate\Contracts\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Collection;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\MorphToMany;
use Illuminate\Database\Eloquent\SoftDeletes;

class Car extends Model implements HasTagsContract
{
    use HasFactory;
    use SoftDeletes;
    use WithoutAncients;

    protected $fillable = ['name', 'price', 'old_price', 'description', 'salon', 'kpp', 'year', 'color', 'is_new', 'characteristics', 'status', 'engine_id', 'class_id', 'body_id', 'image_id'];

    protected $attributes = [
        'is_new' => true,
    ];

    protected $casts = [
        'price' => 'int',
        'old_price' => 'int',
        'is_new' => 'bool',
        'characteristics' => 'array',
        'status' => ModelStatus::class,
    ];

    protected $appends = ['discount_sum'];

    public function discountSum(): Attribute
    {
        return Attribute::make(
            get: fn ($value, $attributes) => isset($attributes['old_price']) ? $attributes['old_price'] - $attributes['price'] : null
        );
    }

    public function image(): BelongsTo
    {
        return $this->belongsTo(Image::class);
    }

    public function salons(): BelongsToMany
    {
        return $this->belongsToMany(Salon::class);
    }

    public function imageUrl(): Attribute
    {
        return Attribute::get(fn () => $this->image?->url ?: '/assets/images/no_image.png');
    }

    public function images(): BelongsToMany
    {
        return $this->belongsToMany(Image::class);
    }

    public function name(): Attribute
    {
        return Attribute::set(fn ($value) => ucfirst($value));
    }

    public function scopeHasDiscount(Builder $query): Builder
    {
        return $query->whereNotNull('old_price');
    }

    public function scopeNovelty(Builder $query): Builder
    {
        return $query->where('is_new', true);
    }

    public function scopeMinPrice(Builder $query, int $minPrice): Builder
    {
        return $query->where('price', '>=', $minPrice);
    }

    public function newCollection(array $models = []): Collection
    {
        return new CarCollection($models);
    }

    public function carClass(): BelongsTo
    {
        return $this->belongsTo(CarClass::class, 'class_id')->withDefault();
    }

    public function engine(): BelongsTo
    {
        return $this->belongsTo(CarEngine::class)->withDefault(['name' => 'Не указан']);
    }

    public function body(): BelongsTo
    {
        return $this->belongsTo(CarBody::class)->withDefault();
    }

    public function category(): BelongsTo
    {
        return $this->belongsTo(Category::class);
    }

    public function tags(): MorphToMany
    {
        return $this->morphToMany(Tag::class, 'taggable');
    }

    public function baskets(): BelongsToMany
    {
        return $this->belongsToMany(Basket::class)->withPivot('quantity');
    }

    public function orders(): HasMany
    {
        return $this->hasMany(Order::class);
    }

    public function fixedProducts(): HasMany
    {
        return $this->hasMany(FixedProduct::class, 'car_id', 'id');
    }

    public function testDrives(): HasMany
    {
        return $this->hasMany(TestDrive::class);
    }
}

app/Http/Controllers/Admin/CarsController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Contracts\Repositories\CarsRepositoryContract;
use App\Contracts\Services\Cars\CarCreationServiceContract;
use App\Contracts\Services\Cars\CarRemoverServiceContract;
use App\Contracts\Services\Cars\CarUpdateServiceContract;
use App\Contracts\Services\FlashMessageContract;
use App\Contracts\Services\TagsSynchronizerServiceContract;
use App\Http\Controllers\Controller;
use App\Http\Requests\Admin\CarRequest;
use App\Http\Requests\TagsRequest;
use App\Models\Car;
use Illuminate\Http\RedirectResponse;
use Illuminate\View\View;

class CarsController extends Controller
{
    public function __construct(
        private readonly CarsRepositoryContract $carsRepository
    ) {
    }

    public function index(): View
    {
        $this->authorize('viewAny', Car::class);

        $cars = $this->carsRepository->findAll();
        return view('pages.admin.cars.list', ['cars' => $cars]);
    }

    public function create(): View
    {
        $this->authorize('create', Car::class);

        return view('pages.admin.cars.create', ['car' => $this->carsRepository->getModel()]);
    }

    public function store(
        CarRequest $request,
        TagsRequest $tagsRequest,
        FlashMessageContract $flashMessage,
        CarCreationServiceContract $carCreationService,
        TagsSynchronizerServiceContract $tagsSynchronizerService,
    ): RedirectResponse {
        $this->authorize('create', Car::class);

        $car = $carCreationService->create($request->validated(), $request->get('category_id'));

        $tagsSynchronizerService->sync($car, $tagsRequest->get('tags'));

        $flashMessage->success('Модель успешно создана');

        return redirect()->route('admin.cars.index');
    }

    public function edit(int $id): View
    {
        $car = $this->carsRepository->getById($id, ['image', 'images']);
        $this->authorize('update', $car);

        return view('pages.admin.cars.edit', ['car' => $car]);
    }

    public function update(
        CarRequest $request,
        TagsRequest $tagsRequest,
        int $id,
        FlashMessageContract $flashMessage,
        CarUpdateServiceContract $carUpdateService,
        TagsSynchronizerServiceContract $tagsSynchronizerService,
    ): RedirectResponse {
        $this->authorize('update', [Car::class, $id]);

        $car = $carUpdateService->update($id, $request->validated(), $request->get('category_id'));

        $tagsSynchronizerService->sync($car, $tagsRequest->get('tags'));

        $flashMessage->success('Модель успешно обновлена');

        return back();
    }

    public function destroy(
        int $id,
        CarRemoverServiceContract $carRemoverService,
        FlashMessageContract $flashMessage,
    ): RedirectResponse {
        $this->authorize('delete', [Car::class, $id]);

        $carRemoverService->delete($id);

        $flashMessage->success('Модель удалена');

        return back();
    }
}

app/Http/Controllers/Api/CarsController.php
<?php

namespace App\Http\Controllers\Api;

use App\Contracts\Repositories\CarsRepositoryContract;
use App\Contracts\Services\Cars\CarCreationServiceContract;
use App\Contracts\Services\Cars\CarRemoverServiceContract;
use App\Contracts\Services\Cars\CarUpdateServiceContract;
use App\DTO\CatalogFilterDTO;
use App\Http\Controllers\Controller;
use App\Http\Requests\Api\CreateCarRequest;
use App\Http\Requests\Api\UpdateCarRequest;
use App\Http\Resources\CarResource;
use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\AnonymousResourceCollection;

class CarsController extends Controller
{
    public function index(
        Request $request,
        CarsRepositoryContract $carsRepository
    ): AnonymousResourceCollection {
        return CarResource::collection($carsRepository->paginateForCatalog(
            new CatalogFilterDTO(),
            ['id', 'name', 'price', 'old_price', 'image_id'],
            $request->get('perPage', 10),
            $request->get('page', 1),
            'page',
            ['image:id,path']
        ));
    }

    public function store(
        CreateCarRequest $request,
        CarCreationServiceContract $carCreationService
    ): CarResource {
        return new CarResource($carCreationService->create($request->validated(), $request->get('category', [])));
    }

    public function show(
        $id,
        CarsRepositoryContract $carsRepository
    ): CarResource {
        return new CarResource($carsRepository->getById($id, ['image:id,path', 'category']));
    }

    public function update(
        UpdateCarRequest $request,
        $id,
        CarUpdateServiceContract $carUpdateService
    ): CarResource {
        return new CarResource($carUpdateService->update($id, $request->validated(), $request->get('category')));
    }

    public function destroy(
        $id,
        CarRemoverServiceContract $carRemoverService
    ): array {
        $carRemoverService->delete($id);

        return [$id];
    }
}

resources/views/pages/admin/cars/create.blade.php
<x-layouts.admin
    page-title="Форма создания модели"
    title="Форма создания модели"
>
    <x-forms.form action="{{ route('admin.cars.store') }}" method="post" enctype="multipart/form-data">

        <x-forms.concrete-forms-fields.admin-car-form-fields :car="$car" />

        <x-forms.row>
            <x-forms.submit-button>
                Сохранить
            </x-forms.submit-button>
            <x-forms.cancel-button href="{{ route('admin.cars.index') }}" >
                Отменить
            </x-forms.cancel-button>
        </x-forms.row>
    </x-forms.form>
</x-layouts.admin>

resources/views/pages/admin/cars/edit.blade.php
<x-layouts.admin
    page-title="Форма редактирования модели"
    title="Форма редактирования модели"
>
    <x-forms.form action="{{ route('admin.cars.update', ['car' => $car]) }}" method="post" enctype="multipart/form-data">
        @method('PATCH')

        <x-forms.concrete-forms-fields.admin-car-form-fields :car="$car" />

        <x-forms.row>
            <x-forms.submit-button>
                Сохранить
            </x-forms.submit-button>
            <x-forms.cancel-button href="{{ route('admin.cars.edit', ['car' => $car]) }}">
                Отменить
            </x-forms.cancel-button>
        </x-forms.row>
    </x-forms.form>
</x-layouts.admin>

resources/views/pages/admin/cars/list.blade.php
<x-layouts.admin
    page-title="Управление моделями"
    title="Управление моделями"
>
    <section class="pb-4">
        @can('create', \App\Models\Car::class)
        <div class="my-6">
            <a href="{{ route('admin.cars.create') }}" class="inline-block bg-orange hover:bg-opacity-70 focus:outline-none text-white font-bold py-2 px-4 rounded" title="Добавить модель">
                <span class="flex items-center space-x-2">
                    <svg xmlns="http://www.w3.org/2000/svg" class="inline-block h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor" stroke-width="2">
                        <path stroke-linecap="round" stroke-linejoin="round" d="M12 9v3m0 0v3m0-3h3m-3 0H9m12 0a9 9 0 11-18 0 9 9 0 0118 0z" />
                    </svg>
                    <span>Добавить модель</span>
                </span>
            </a>
        </div>
        @endcan

        <table class="border border-collapse w-full">
            <thead>
            <tr>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">id</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">Название модели</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">Цена с учетом скидки</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">Цена без скидки</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">Новинка</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">&nbsp;</th>
                <th class="border px-4 py-2 border-gray-600 bg-gray-200 font-bold">&nbsp;</th>
            </tr>
            </thead>
            <tbody>
            @foreach ($cars as $car)
            <tr>
                <td class="border px-4 py-2">{{ $car->id }}</td>
                <td class="border px-4 py-2">{{ $car->name }}</td>
                <td class="border px-4 py-2"><x-price :price="$car->price" /></td>
                <td class="border px-4 py-2">@isset ($car->old_price)<x-price :price="$car->old_price" />@endisset</td>
                <td class="border px-4 py-2">{{ $car->is_new ? 'Да' : 'Нет' }}</td>
                <td class="border px-4 py-2">
                    @can('update', $car)
                        <div class="flex items-center">
                            <a href="{{ route('admin.cars.edit', ['car' => $car]) }}" class="inline-block bg-orange hover:bg-opacity-70 focus:outline-none text-white font-bold py-2 px-4 rounded" title="Редактировать">
                                <svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5" viewBox="0 0 20 20" fill="currentColor">
                                    <path d="M17.414 2.586a2 2 0 00-2.828 0L7 10.172V13h2.828l7.586-7.586a2 2 0 000-2.828z" />
                                    <path fill-rule="evenodd" d="M2 6a2 2 0 012-2h4a1 1 0 010 2H4v10h10v-4a1 1 0 112 0v4a2 2 0 01-2 2H4a2 2 0 01-2-2V6z" clip-rule="evenodd" />
                                </svg>
                            </a>
                        </div>
                    @endcan
                </td>
                <td class="border px-4 py-2">
                    @can('delete', $car)
                        <form class="flex items-center" action="{{ route('admin.cars.destroy', ['car' => $car]) }}" method="post">
                            @csrf
                            @method('DELETE')
                            <button class="inline-block bg-gray-400 hover:bg-opacity-70 focus:outline-none text-white font-bold py-2 px-4 rounded" title="Удалить" onclick="return confirm('вы уверены, что хотите удалить эту модель?')">
                                <svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5" fill="none" viewBox="0 0 24 24" stroke="currentColor" stroke-width="2">
                                    <path stroke-linecap="round" stroke-linejoin="round" d="M19 7l-.867 12.142A2 2 0 0116.138 21H7.862a2 2 0 01-1.995-1.858L5 7m5 4v6m4-6v6m1-10V4a1 1 0 00-1-1h-4a1 1 0 00-1 1v3M4 7h16" />
                                </svg>
                            </button>
                        </form>
                    @endcan
                </td>
            </tr>
            @endforeach
            </tbody>
        </table>
    </section>
</x-layouts.admin>